<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';

///////////////////////////////////////////////////////////////////////////

class TvGroupListScreen extends AbstractPreloadedRegularScreen
 implements UserInputHandler
{
    const ID = 'tv_group_list';

    ///////////////////////////////////////////////////////////////////////

    protected $tv;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($tv, $folder_views)
    {
        parent::__construct(self::ID, $folder_views);

        $this->tv = $tv;
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$jsd = SmartConfig::hlsclient();
		if ((isset($jsd->success->trashed->type))&&($jsd->success->trashed->type == 'paused'))
			$days = "Услуга Приостановлена";
		else if (isset($jsd->success->set_of_channels_restriction))
			$days = $jsd->success->set_of_channels_restriction;
		else if (isset($jsd->success->trashed->expired)){
			if ($jsd->success->trashed->type == 'big')
				$arg = 'Большое промо ';
			else if ($jsd->success->trashed->type == 'small')
				$arg = 'Малое промо ';
			else
				$arg = '';
			$days = $arg . "Дней Просмотра: " . $jsd->success->trashed->expired;
		}else if (isset($jsd->error))
			$days = 'Error: '. $jsd->error_msg .' - '. $jsd->error;
		else if (isset($jsd->success->message)){
			$days =  $jsd->success->message->name;
		}else
			$days = 'Error!';
		$actions[GUI_EVENT_KEY_ENTER] = ActionFactory::open_folder();
		$actions[GUI_EVENT_KEY_PLAY]  = ActionFactory::tv_play();
		$add_action = ActionFactory::open_folder(SmartSetupScreen::get_media_url_str(),'Настройки');
		$add_action['caption'] = 'Настройки';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		$actions[GUI_EVENT_KEY_SETUP] = $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'omegaInfo');
        $add_action['caption'] = $days;
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
		return  $actions;
    }
	
	public function get_handler_id()
    { return self::ID; }
    ///////////////////////////////////////////////////////////////////////
	
	public function handle_user_input(&$user_input, &$plugin_cookies)
    {
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		if ($user_input->control_id == 'omegaInfo'){
			$jsd = SmartConfig::hlsclient();
			if ((isset($jsd->success->trashed->type))&&($jsd->success->trashed->type == 'paused'))
				ControlFactory::add_label($defs, '', "Услуга Приостановлена");
			else if (isset($jsd->success->set_of_channels_restriction))
				ControlFactory::add_label($defs, '', $jsd->success->set_of_channels_restriction);
			else if (isset($jsd->success->trashed->expired)){
				if ($jsd->success->trashed->type == 'big')
					$arg = 'Большое промо ';
				else if ($jsd->success->trashed->type == 'small')
					$arg = 'Малое промо ';
				else
					$arg = '';
				ControlFactory::add_label($defs, '', $arg . "Дней Просмотра: " . $jsd->success->trashed->expired);
			}else if (isset($jsd->error))
				ControlFactory::add_label($defs, '', 'Error: '. $jsd->error_msg .' - '. $jsd->error);
			else if (isset($jsd->success->message)){
				ControlFactory::add_label($defs, '', $jsd->success->message->name);
				ControlFactory::add_label($defs, '', $jsd->success->message->phone);
				ControlFactory::add_label($defs, '', $jsd->success->message->url);
			}else
				ControlFactory::add_label($defs, '', 'Error!');
			ControlFactory::add_label($defs, '', "Серийный номер:");
			ControlFactory::add_vgap($defs, (-30));
			ControlFactory::add_label($defs, '', HD::get_serial_number());
			$action = UserInputHandlerRegistry::create_action($this, 'change_omega_key');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'omega_key', 'Ввести код', 350, $action);
			ControlFactory::add_close_dialog_button($defs, 'ОК', 350);
			return ActionFactory::show_dialog('Подписка', $defs, true, 0,$attrs);
        }
		if ($user_input->control_id == 'omega_key'){
			if (($user_input->omega_key == false)&&(strlen($user_input->omega_key) != 4))
				return UserInputHandlerRegistry::create_action($this, 'change_omega_key');
			$jsd = SmartConfig::hlsclient($user_input->omega_key);
			if (!isset($jsd->success)){
				$trashed = '';	
				if (isset($jsd->trashed->type))
					$trashed = $jsd->trashed->type;				
				throw new DuneException(
					'HTTP network error', 0,
					ActionFactory::show_error(
					true,
					'Error: '. $jsd->error_msg .' - '. $jsd->error,
					array(
						$jsd->message->name,
						$jsd->message->phone,
						$trashed))
				);
			}
			$perform_new_action = ActionFactory::launch_media_url('plugin_launcher://' . DuneSystem::$properties['plugin_name']);;
			return ActionFactory::invalidate_folders(array('tv_channel_list'), $perform_new_action);
		}
		if ($user_input->control_id === 'change_omega_key'){
			$defs = array();
			if ((!isset($user_input->omega_key))||($user_input->omega_key == false))
				$omega_key = 'Введите код';
			ControlFactory::add_multiline_label($defs, '', "Код активации (получить в личном кабинете cabinet.mynet.ua)", 6);
			ControlFactory::add_text_field($defs,
				$handler=null, $add_params=null,
				'omega_key', '',
				$omega_key, 0, 0, 0, 0, 1050);
			ControlFactory::add_smart_label($defs,"", '<text dy="7" size="small"> Нажмите </text><icon>gui_skin://special_icons/controls_button_blue.aai</icon><text dy="7" size="small"> для вызова экранной клавиатуры</text>');
			$action = UserInputHandlerRegistry::create_action($this, 'omega_key');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'omega_key', 'Применить', 350, $action);
			return ActionFactory::show_dialog('Введите код доступа', $defs, true, 1100, $attrs);
		}
	}
    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $this->tv->folder_entered($media_url, $plugin_cookies);
        $this->tv->ensure_channels_loaded($plugin_cookies);
        $items = array();
        foreach ($this->tv->get_groups() as $group){
            $media_url = $group->is_favorite_channels() ?
                TvFavoritesScreen::get_media_url_str() :
                TvChannelListScreen::get_media_url_str($group->get_id());

            $items[] = array
            (
                PluginRegularFolderItem::media_url => $media_url,
                PluginRegularFolderItem::caption => $group->get_title(),
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $group->get_icon_url(),
                    ViewItemParams::item_detailed_icon_path => $group->get_icon_url()
                )
            );
        }
        $this->tv->add_special_groups($items);
        return $items;
    }

    public function get_archive(MediaURL $media_url){
        return $this->tv->get_archive($media_url);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
